#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const long MAX_SIZE = 15;
const long MAX_STEPS = MAX_SIZE*MAX_SIZE+1;

char dX[8] = {3, 1, -1, -3, -3, -1, 1, 3};
char dY[8] = {1, 3, 3, 1, -1, -3, -3, -1};

long cRows, cCols, sRow, sCol, dRow, dCol;

struct Point
{
	char x;
	char y;
	Point (char xx = 0, char yy = 0) : x(xx), y(yy){}


	int IsValid()
	{
		return (x >= 0 && y >= 0 && x < cRows && y < cCols);
	}
};

Point parent[MAX_STEPS][MAX_SIZE][MAX_SIZE];

char inWay[MAX_SIZE][MAX_SIZE];


void BuildInWay(long iStep, char row, char col)
{
	memset(inWay, 0, sizeof(inWay));

	Point p(row, col);
	for (; iStep >= 0; --iStep)
	{
		inWay[p.x][p.y] = 1;

        p = parent[iStep][p.x][p.y];
	}

}

int is_prime(long num)
{
	if(num < 2) return 0;
	if(num < 4) return 1;
	for(long factor = 2; factor < num/2; ++factor)
	{
		if(num % factor == 0) return 0;
	}
	return 1;
}

int isPrime[MAX_STEPS];

int main(void)
{
#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	long i;
	for (i = 0; i < MAX_STEPS; ++i)
		isPrime[i] = is_prime(i);


	long iCase = 0;

	while (scanf("%ld %ld %ld %ld %ld", &cRows, &cCols, &sRow, &sCol, &dRow, &dCol) == 5)
	{
		++iCase;
		memset(parent, -1, sizeof(parent));
		--sRow;
		--sCol;
		--dRow;
		--dCol;
//		parent[0][sRow][sCol] = Point(-2, -2);


		long iStep;
		long maxSteps = cRows*cCols;
		char row, col, dir;

		for (iStep = 0; iStep < maxSteps; ++iStep)
		{
			for (row = 0; row < cRows; ++row)
			{
				for (col = 0; col < cCols; ++col)
				{
					if (parent[iStep][row][col].x < 0) continue;

					BuildInWay(iStep, row, col);

					if (parent[iStep][row][col].IsValid())
					{
						for (dir = 0; dir < 8; ++dir)
						{
						if (!Point(row+dX[dir], col+dY[dir]).IsValid())
							if (parent[iStep+1][row][col].x < 0 && !inWay[row+dX[dir], col+dY[dir]])
							{
								parent[iStep+1][row][col] = Point(row+dX[dir], col+dY[dir]);
							}

						}

					}
				}
			}
		}


		int foundPrime = 0;
		int found = 0;
		int res;

		for (i = 0; i < maxSteps; ++i)
		{
			if (isPrime[i] && parent[i][dRow][dCol].x >= 0)
			{
				res = i;
				foundPrime = 1;
				found = 1;
				break;
			}
		}
        

		if (!found)
		{
			for (i = 0; i < maxSteps; ++i)
			{
				if (parent[i][dRow][dCol].x >= 0)
				{
					res = i;
					found = 1;
					break;
				}
			}
		}


		printf("CASE# %ld: ", iCase);
		if (foundPrime)
		{
            printf("The knight takes %ld prime moves.\n", res);
		}
		else
		{
			if (found)
			{
				printf("The knight takes %ld composite move(s).", res);
			}
			else
			{
				printf("Destination is not reachable.\n");
			}


		}
        
	}

#ifndef ONLINE_JUDGE
	fclose(stdout);
	fclose(stdin);
#endif

	return 0;
}